use std::{collections::HashMap, io};
use async_trait::async_trait;

use crate::types::{participant::Participant, project::ProjectRaw, user::User};

#[async_trait]
pub trait Service {
    fn get_name(&self) -> &'static str;

    fn setup(&self) -> Box<dyn Service>;
    async fn load(&mut self) -> io::Result<()>;

    fn get_participants(&self) -> Vec<Participant>;
    async fn merge_messages(&self, raw_project: &mut ProjectRaw, user_map: &HashMap<Participant, User>);
}
